/**************************************************************************************************

Copyright (c) 2007-2012  Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_screen_menu.h"
#include  "mtk_object.h"
#include  "mtk_switches.h"
#include  "mtk_3D_chart.h"
#include  "mtk_colors.h"
#include  "mtk_movie.h"
#include  "mtk_ini_file.h"
#include  "mtk_title_page.h"
#include  "mtk_solar_system.h"
#include  "mtk_planets.h"
#include  "mtk_spacecraft.h"
#include  "mtk_target.h"
#include  "mtk_movement.h"
#include  "mtk_window_mode.h"
#include  "mtk_preset_scene.h"
#include  "mtk_font.h"
#include  "mtk_camera_setting.h"
#include  "mtk_command.h"
#include  "mtk_tcp.h"
#include  "mtk_mode.h"
#include  "mtk_preset_target.h"
#include  "mtk_objects.h"




//************
extern MediaFiles MVF, AUDF, IMGF;
extern char  tyProgram;
extern char szLandingPosNameJ[256];
extern char szLandingPosNameE[256];
extern float FontSize;
extern float vFontSize[5];
extern bool	bControler;
//************




//--------
//  Menu
//--------
const float menu_angle_max =  50.0f;
const float menu_angle_min = -50.0f;
static float menu_angle = 0.0;
static float MenuTextSize;
float MenuBdWidth;
float MenuTriangleDy;



//--  Menu
static bool  bMenuVisible		= true;		// j[\邩ǂ
const char* szMenuTextColorDef		= "#A59FA5";
const char* szMenuSelectColorDef	= "#DEDED3";
const char* szMenuTitleColorDef		= "#EBBE47";
const char* szMenuBgColor1Def		= "#464E64";
const char* szMenuBgColor2Def		= "#000000";
const char* szMenuBdColorDef		= "#3E4557";
const char* szMenuHlColor1Def		= "#599AE5";
const char* szMenuHlColor2Def		= "#2764D2";
RGBf colMenuText, colMenuSelect, colMenuTitle;
RGBf colMenuBgColor1, colMenuBgColor2, colMenuBdColor;
RGBf colMenuHlColor1, colMenuHlColor2;
float MenuCornerR, MenuBgAlpha, MenuBehindAlpha, MenuFadingRate;







struct menu_color {
	RGBAf  txt_color, select_color, title_color;
	RGBAf  bg_color, bd_color;
};



//****
menu			menu_root;
//****
static menu			menu_disp, menu_target, menu_time, menu_system, menu_path, menu_preset;
static menu			menu_movie, menu_image, menu_audio, menu_3Dchart;
static menu_option  menu_scale;
static menu_option		menu_target_solarsystem, menu_target_spacecraft, menu_target_galactic, menu_target_extragalactic;
static menu			menu_planet, menu_satellite, menu_minor_planet, menu_TNO;
static menu			menu_cnst, menu_star, menu_eclipse, menu_spacecraft, menu_galaxy, menu_grid;
static menu_option		menu_program, menu_clst_sphere, menu_lang, menu_timestep, menu_star_mark;
static menu_option		menu_atmosphere, menu_zoom_mode, menu_topo_zoom, menu_font_size, menu_landing_mode;

//*****
menu_selection	mnuSelect;
//*****

static menu_color		mnu_col, mnu_col_bk;






struct menu_item_def {
	const char* nameJ;
	const char* nameE;
	int	idx;
};


struct menu_item_object_def {
	const char* nameJ;
	const char* nameE;
	const char* obj_key;
};







//-----------
//  Get/Set
//-----------
bool
is_menu_visible()
{
	return  bMenuVisible;
}

void
set_menu_visible(bool bFlg)
{
	bMenuVisible = bFlg;
}

float
get_menu_text_size()
{
	return  MenuTextSize;
}

void
set_menu_text_size(float sz)
{
	MenuTextSize = sz;
}

float
get_menu_angle()
{
	return  menu_angle;
}




//--------
//  Init
//--------
void
init_option_menu(menu_option& mn, int num, int MENU_ID, const char* titleJ, const char* titleE, const menu_item_def* mndf, int ini_check_no)
{
	mn.set_title(titleJ, titleE);
	for (int i=0; i<num; ++i) {
		bool bChk = (i==ini_check_no);
		mn.add_check(MENU_ID, mndf[i].nameJ, mndf[i].nameE, mndf[i].idx, bChk);
	}
}



void
init_option_menu_object(menu_option& mn, int num, int MENU_ID, const char* titleJ, const char* titleE,
						const menu_item_object_def* mndf, int ini_check_no)
{
	mn.set_title(titleJ, titleE);
	for (int i=0; i<num; ++i) {
		bool bChk = (i==ini_check_no);
		mn.add_check(MENU_ID, mndf[i].nameJ, mndf[i].nameE, get_object_ID(mndf[i].obj_key), bChk);
	}
}





int virgo_menu_idx;


//-- [gj[̐ݒ
void
init_root_menu()
{
    menu_root.set_title("Cj[", "Main Menu");

	menu_root.clear();
	if (MVF.size() > 0)		menu_root.add_child_menu( &menu_movie,	"[r[",	"Movies" );
	if (IMGF.size() > 0)	menu_root.add_child_menu( &menu_image,	"摜",		"Images" );
	if (AUDF.size() > 0)	menu_root.add_child_menu( &menu_audio,	"",		"Audio" );
	menu_root.add_child_menu( &menu_3Dchart,				"Rc`[g",		"3D Chart" );


	//--- \ݒ
	menu_root.add_child_menu( &menu_disp,				"\ݒ", "Display Settings" );
	if (tyProgram==2) {
		menu_root.add_command(MENU_COMMAND_DRAW_MILKYWAY2, 0,	"邢V̐\", "Bright Milky Way");
		menu_root.add_command(MENU_COMMAND_DRAW_MILKYWAY,  0,	"V̐\", "Milky Way");
	}
	if (tyProgram==2 || tyProgram==4) {
		menu_root.add_child_menu( &menu_star_mark, "̃}[N", "Mark Stars" );
	}
	if (tyProgram==5) {
		menu_root.add_check(MENU_CHECK_GALAXY_VIRGO, "Ƃߍ͒c}[N", "Mark Virgo Cluster", 0, false);
		virgo_menu_idx = menu_root.size() - 1;
	}


	//--- ^[Qbg
	menu_root.add_child_menu( &menu_target,				"^[Qbg", "Target" );
	menu_root.add_command( MENU_COMMAND_TARGET_MOVE, 0, "^[Qbgt߂Ɉړ", "Move to the target" );
	if (tyProgram==3) {
        menu_root.add_child_menu( &menu_target_solarsystem,		"zn̓V", "Solar System");
	}

	menu_root.add_command(MENU_COMMAND_GOTO, 0,	"n", "Go to Earth");

	if (tyProgram>=0 && tyProgram<=4) {
		menu_root.add_command(MENU_COMMAND_PRESET, PRESET_SOLARSYSTEM_COMPLETE_VIEW,	"znSi", "Complete View of Solar System");
	}

	if (tyProgram==0 || tyProgram==1 || tyProgram==2) {
		menu_root.add_command(MENU_COMMAND_GOTO, 2,	"΂", "Go to Pleiades");
	}
	if (tyProgram==2 || tyProgram==4) {
		menu_root.add_command(MENU_COMMAND_GOTO, 3,	"M13", "Go to M13");
	}
	if (tyProgram==2) {
		menu_root.add_command(MENU_COMMAND_GOTO, 4,	"͌nS", "Go to Galactic Center");
	}
	if (tyProgram==3) {
			menu_root.add_command(MENU_COMMAND_GOTO, 1, "JbV[j", "Go to Cassini");
	}
	if (tyProgram==4) {
		menu_root.add_child_menu( &menu_target_spacecraft, "T@", "Go to Spacecraft" );
	}
	if (tyProgram==4) {
		menu_root.add_command(MENU_COMMAND_PRESET, PRESET_SPACECRAFT_PATH, "T@̋O", "Display Trajectory of Spacecraft");
	}
	if (tyProgram==5) {
		menu_root.add_command(MENU_COMMAND_GOTO, 5,	"Ƃߍ͒c", "Go to Virgo Cluster");
	}


	char strJ[256], strE[256];
	sprintf(strJ, "%s֒", szLandingPosNameJ);
	sprintf(strE, "Landing on %s", szLandingPosNameE);
	menu_root.add_command(MENU_COMMAND_LANDING_INIT, 0,	strJ, strE);

	menu_root.add_child_menu( &menu_time,				"", "Time" );
	

	// XP[
	menu_root.add_child_menu( &menu_scale, "XP[", "Scale" );


	// [r[쐬j[
	if (bEnableMovieMake) {
		menu_root.add_child_menu( &menu_path,				"pXݒ", "Set Path" );
	}
	
	// VXej[
	if (bEnableSystemMenu) {
		menu_root.add_child_menu( &menu_system,				"VXe", "System" );
	}
}



//-- j[̏
void
init_menu()
{
	//-- [gj[
	init_root_menu();


	//-- \ݒ胁j[
	menu_disp.set_title("\ݒ", "Display Settings");
	menu_disp.add_child_menu( &menu_planet,				"f",			"Planets" );
	menu_disp.add_child_menu( &menu_satellite,			"q",			"Satellites" );
	menu_disp.add_child_menu( &menu_minor_planet,		"f",		"Minor Planets" );
	menu_disp.add_child_menu( &menu_TNO,				"znOV",	"Transneptunian Objects" );
	
	menu_disp.add_child_menu( &menu_star,				"P",			"Stars" );
	menu_disp.add_child_menu( &menu_cnst,				"",			"Constellations" );
	menu_disp.add_child_menu( &menu_spacecraft,			"T@̋O",	"Trajectory of Spacecraft" );
	menu_disp.add_child_menu( &menu_clst_sphere,		"V̐",		"Milky Way" );
	menu_disp.add_child_menu( &menu_galaxy,				"",			"Galaxies" );
	menu_disp.add_check( MENU_CHECK_NGC,				"NGCV",		"NGC Objects", 0, false );
	menu_disp.add_child_menu( &menu_grid,				"oܐ",		"Grid" );
	menu_disp.add_command( MENU_COMMAND_RESET_VIEWANGLE, 0, "pZbg", "Reset View Angle" );
	menu_disp.add_check( MENU_CHECK_SIDE_LIGHT,			"wbhCg",	"Headlight", 0, false );
	menu_disp.add_check( MENU_CHECK_SURFACE_POINTER,	"n\̃|C^",	"Surface Pointer", 0, false );
	menu_disp.add_check( MENU_CHECK_VIEW_INFO,			"_",		"View Info", 0,		true );

	//-- ^[QbgṼj[
	menu_target.set_title("^[Qbg", "Target" );
	menu_target.add_child_menu( &menu_target_solarsystem,	"zn",	"Solar System Objects" );
	menu_target.add_child_menu( &menu_target_spacecraft,	"T@",	"Spacecraft" );
	menu_target.add_child_menu( &menu_target_galactic,		"P",		"Stars" );
	menu_target.add_child_menu( &menu_target_extragalactic,	"͌nOV", "Extragalactic Objects" );
	menu_target.add_command( MENU_COMMAND_TARGET_MOVE, 0, "^[Qbgt߂Ɉړ", "Go to the Target" );


	//--- zn^[Qbg ---
	const menu_item_object_def  mdf_ss[] = {
		{ "z",	"Sun",		"Sun" },
		{ "",	"Mercury",	"Mercury" },
		{ "",	"Venus",	"Venus" },
		{ "n",	"Earth",	"Earth" },
		{ "ΐ",	"Mars",		"Mars" },
		{ "ؐ",	"Jupiter",	"Jupiter" },
		{ "y",	"Saturn",	"Saturn" },
		{ "V",	"Uranus",	"Uranus" },
		{ "C",	"Neptune",	"Neptune" },
		{ "",	"Pluto",	"Pluto" },
		{ "GX",	"Eris",		"SmallBody136199" },
		{ "Zhi",	"Sedna",	"SmallBody90377" },
		{ "",		"Moon",		"Moon" },
		{ "CI",	"Io",		"Io" },
	};
	init_option_menu_object( menu_target_solarsystem, 14, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_ss, 0);


	//--- T@^[Qbg ---
	const menu_item_object_def  mdf_spccrf[] = {
		{ "pCIjAPO",	"Pioneer10",	"Pioneer10" },
		{ "pCIjAPP",	"Pioneer11",	"Pioneer11" },
		{ "{CW[P",	"Voyager I",	"VoyagerI" },
		{ "{CW[Q",	"Voyager II",	"VoyagerII" },
		{ "JbV[j",		"Cassini",		"Cassini" },
	};
	init_option_menu_object( menu_target_spacecraft, 5, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_spccrf, 0);


	//--- ͌n^[Qbg ---
	const menu_item_object_def  mdf_galactic[] = {
		{ "At@EP^E",	"Alpha Centauri",	"HIP71683" },
		{ "VEX",				"Sirius",			"HIP32349" },
		{ "΂",				"Pleiades",			"HIP17702" },
		{ "JXg",				"Castor",			"HIP36850" }
	};
	init_option_menu_object( menu_target_galactic, 4, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_galactic, 0);




	//--- ͌nO^[Qbg ---
	const menu_item_object_def  mdf_extragalactic[] = {
		{ "M13",			"M13",							"M13" },
		{ "͌nS",		"Galactic Center",				"OurGalaxy" },
		{ "Ah_",	"Andromeda Galaxy",				"NGC224" },
		{ "Ƃߍ͒c",	"Virgo Cluster",				"NGC4486" }
	};
	init_option_menu_object( menu_target_extragalactic, 4, MENU_CHECK_TARGET, "^[Qbg", "Target", mdf_extragalactic, 0);


	//-- XP[ --
	const int menu_scale_num = 17;
	const menu_item_def  mdf_scale[menu_scale_num] = {
		{ "1000km",			"1000 km",				SCALE_1000KM },
		{ "1VP",		"1 AU",					SCALE_1AU },
		{ "10VP",		"10 AU",				SCALE_10AU },
		{ "100VP",		"100 AU",				SCALE_100AU },
		{ "1000VP",		"1 thousand AU",		SCALE_1000AU },
		{ "1VP",		"10 thousand AU",		SCALE_10000AU },
		{ "1N",			"1 l.y.",				SCALE_1LY },
		{ "10N",			"10 l.y.",				SCALE_10LY },
		{ "100N",			"100 l.y.",				SCALE_100LY },
		{ "1000N",		"1 thousand l.y.",		SCALE_1KLY },
		{ "1N",			"10 thousand l.y.",		SCALE_10KLY },
		{ "10N",		"100 thousand l.y.",	SCALE_100KLY },
		{ "100N",		"1 million l.y.",		SCALE_1MLY },
		{ "1000N",		"10 million l.y.",		SCALE_10MLY },
		{ "1N",			"100 million l.y.",		SCALE_100MLY },
		{ "10N",		"1 billion l.y.",		SCALE_1GLY },
		{ "100N",		"10 billion l.y.",		SCALE_10GLY },
	};
	for (int i=0; i<menu_scale_num; i++) {
		const menu_item_def&  mdf = mdf_scale[i];
		menu_scale.add_command(MENU_COMMAND_SCALE, mdf.idx, mdf.nameJ, mdf.nameE);
	}



	//-- j[ --
	menu_time.set_title("", "Time");
	menu_time.add_check( MENU_CHECK_DATE,					"̕\",			"Display Date",		0, false );
	menu_time.add_command( MENU_COMMAND_PRESENT_TIME, 0,	"݂̎ɐݒ",	"Set to Present Time" );
	menu_time.add_child_menu( &menu_timestep,				"i߂鎞",			"Time Step" );
	menu_time.add_check( MENU_CHECK_REALTIME_MODE, 			"ԃ[h",		"Realtime Mode",	0, false );

	//-- Cxg
	menu_preset.set_title("vZbg", "Preset");
	menu_preset.add_command( MENU_COMMAND_PRESET, PRESET_MARS_2003,			"ΐڋ", "Mars 2003");
	menu_preset.add_command( MENU_COMMAND_PRESET, PRESET_SPACECRAFT_PATH,	"T@̋O", "Trajectory of Spacecraft");
    
	//-- VXej[
	menu_system.set_title("VXeݒ", "System");
	menu_system.add_child_menu( &menu_program,			"ԑg̑I",		"Select Program");
	menu_system.add_child_menu( &menu_lang,				"",			"Language" );
	menu_system.add_child_menu( &menu_font_size,		"TCY",		"Text Size" );
	menu_system.add_check( MENU_CHECK_FULLSCREEN,		"Sʃ[h",	"FullScreen Mode",0,	true );
	menu_system.add_check( MENU_CHECK_SUBTITLES,		"[h",		"Subtitle Mode",0,	true );
	menu_system.add_check( MENU_CHECK_TITLE,			"^Cg",		"Title",		0,	true );
	menu_system.add_check( MENU_CHECK_ABOUT,			"o[W",	"Version Info",	0,	true );
	menu_system.add_check( MENU_CHECK_DEBUG,			"fobO",	"Debug Info",	0,	true );
	menu_system.add_check( MENU_CHECK_SINGLE_EYE,		"Eڗpf̂",	"Only Right Eye Image", 0,	true );
	menu_system.add_command( MENU_COMMAND_EXIT_ALL,		0, "SI", "Exit All" );

	//-- ԑgI
	const int menu_program_num = ThemeNum;
	const menu_item_def  mdf_program[ThemeNum] = {
		{ "F̊Kw\i_CWFXgŁj",	"Hierarchical Structure of the Universe (Digest)",	0 },
		{ "F̊Kw\iWjAŁj",		"Hierarchical Structure of the Universe (Junior)",	1 },
		{ "V̐̔閧",						"Milky Way",										2 },
		{ "znIs",						"Solar System",										3 },
		{ "znz",					"Beyond the Solar System",							4 },
		{ "͂̐E",						"World of Galaxies",								5 },
		{ "Փ˂",						"Colliding Galaxies",								6 }
	};
	init_option_menu( menu_program, menu_program_num, MENU_CHECK_PROGRAM, "ԑgI", "Select Program", mdf_program, 0);

	//-- tHgTCYEj[
	const int menu_font_size_num = 5;
	const menu_item_def  mdf_font_size[] = {
		{ "ő",		"Largest",		0},
		{ "",			"Larger",		1 },
		{ "",			"Middle",		2 },
		{ "",			"Smaller",		3 },
		{ "ŏ",		"Smallest",		4 }
	};
	init_option_menu( menu_font_size, menu_font_size_num, MENU_CHECK_FONT_SIZE, "TCY", "Text Size", mdf_font_size, 0);


	//-- pXj[
	menu_path.set_title("pXݒ", "Pass Settings");
	menu_path.add_check( MENU_CHECK_PATH_INFO,			"pX",	"Path Info", 0, true );
	menu_path.add_command( MENU_COMMAND_PLAY_PATH,	0,	"pX̍Đ", "Play Path" );
	menu_path.add_command( MENU_COMMAND_SAVE_PATH,	0,	"pXۑ", "Save Path" );
	menu_path.add_command( MENU_COMMAND_LOAD_PATH,	0,	"pX̓Ǎ", "Load Path" );
	menu_path.add_command( MENU_COMMAND_CLEAR_PATH,	0,	"pX̃NA", "Clear Path" );

	//-- [r[
	menu_movie.set_title("[r[", "Movies");
	for (int i=0; i<MVF.size(); i++) {
		menu_movie.add_command(MENU_COMMAND_MOVIE_OPEN, i, MVF[i].menu_title, MVF[i].menu_title);
	}

	//-- 摜
	menu_image.set_title("摜", "Images");
	for (int i=0; i<IMGF.size(); i++) {
		menu_image.add_command(MENU_COMMAND_IMAGE_OPEN, i, IMGF[i].menu_title, IMGF[i].menu_title);
	}

	//-- 
	menu_audio.set_title("", "Audio");
	for (int i=0; i<AUDF.size(); i++) {
		menu_audio.add_command(MENU_COMMAND_AUDIO_OPEN, i, AUDF[i].menu_title, AUDF[i].menu_title);
	}


	//-- Rc`[g
	menu_3Dchart.set_title("Rc`[g", "3D Chart");
	menu_3Dchart.add_command( MENU_COMMAND_3DCHART, _3DCHART_PLANETS,			"zn̘f",	"Planets");
	menu_3Dchart.add_command( MENU_COMMAND_3DCHART, _3DCHART_DWARF_PLANETS,		"znOV",	"Large TNOs");
	menu_3Dchart.add_command( MENU_COMMAND_3DCHART, _3DCHART_STAR_COLOR,		"̐FƉx",	"Color and Temperature of Stars");

	//-- j[
	menu_cnst.set_title("", "Constellations");
	menu_cnst.add_check( MENU_CHECK_CNST_NAME,			"",	"Names",	0, false );
	menu_cnst.add_check( MENU_CHECK_CNST_LINE,			"",	"Lines",	0, false );
	menu_cnst.add_check( MENU_CHECK_CNST_ILLUST,		"G",	"Illustrations", 0, false );
	menu_cnst.add_check( MENU_CHECK_CNST_BND,			"E",	"Boundaries", 0, false );

	//-- Pj[
	menu_star.set_title("P", "Stars");
	menu_star.add_check( MENU_CHECK_STAR,				"̕\",	"Display Stars",	0,	false );
	menu_star.add_check( MENU_CHECK_STAR_NAME,			"ŗL",	"Proper Name",		0,	false );
	menu_star.add_check( MENU_CHECK_STAR_NAME_SELECT,	"IŗL̂", "Selected Proper Name", 0,	false );
	menu_star.add_check( MENU_CHECK_STAR_BAYER,			"oCG",	"Bayer Name",		0,			false );
	menu_star.add_check( MENU_CHECK_STAR_FRAMSTEED,		"tX`[hԍ", "Flamsteed Number", 0,	false );
	menu_star.add_check( MENU_CHECK_STAR_HIP,			"HIPԍ", "HIP Number",			0,			false );
	menu_star.add_command( MENU_COMMAND_STAR_BRIGHTEN,	0, "邭", "Brighten" );
	menu_star.add_command( MENU_COMMAND_STAR_DARKEN,	0, "Â",	"Darken" );
	menu_star.add_command( MENU_COMMAND_STAR_DEFAULT_BRIGHTNESS,	0, "W̖邳", "Default Brightness" );
	menu_star.add_child_menu( &menu_star_mark, "}[N", "Mark" );

	//-- ̃}[N
	const int menu_star_mark_num = 3;
	const menu_item_def  mdf_star_mark[] = {
		{ "Ȃ",	"None",						0 },
		{ "An",	"Binary Stars",				1 },
		{ "nOf",	"Stars with Exoplanets",	2 }
	};
	init_option_menu( menu_star_mark, menu_star_mark_num, MENU_CHECK_STAR_MARK, "}[N", "Mark",  mdf_star_mark, tyStarMark);


	//-- fj[
	menu_planet.set_title("f", "Planets");
	menu_planet.add_check( MENU_CHECK_PLANETS,				"f",		"Planets",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_NAME,			"O",		"Names",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_ORBIT,			"O",		"Orbits",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_AXIS,			"]",	"Axis of Rotation", 0,	false );
	menu_planet.add_child_menu( &menu_atmosphere,			"C",		"Atmosphere" );
	menu_planet.add_check( MENU_CHECK_PLANET_CLOUD,			"_",		"Cloud",		0,		false );
	menu_planet.add_check( MENU_CHECK_PLANET_CITY_LIGHTS,	"X",	"City Lights",	0,		false );
	menu_planet.add_child_menu( &menu_eclipse,				"̉e",	"Shadow of Moon");
	menu_planet.add_child_menu( &menu_zoom_mode,			"g嗦", "Zoom Rate" );
	menu_planet.add_child_menu( &menu_topo_zoom,			"n`̔{", "Amplification of Topography" );
	menu_planet.add_child_menu( &menu_landing_mode,			"[h", "Landing Mode");


	//-- qj[
	menu_satellite.set_title("q", "Satellites");
	menu_satellite.add_check( MENU_CHECK_SATELLITE_DISP,	"\",			"Display",					0,		false );
	menu_satellite.add_check( MENU_CHECK_SATELLITE_NAME,	"O",			"Names",					0,		false );
	menu_satellite.add_check( MENU_CHECK_SATELLITE_ORBIT,	"O",			"Orbits",					0,		false );
	menu_satellite.add_check( MENU_CHECK_SATELLITE_SELECT,	"ȉq̂",	"Selected Satellites Only",	0,		false );

	//-- fj[
	menu_minor_planet.set_title("f", "Minor Planets");
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_DISP,		"\",				"Display",				0,		false );
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_NAME,		"O",				"Names",				0,		false );
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_ORBIT,		"O",				"Orbits",				0,		false );
	menu_minor_planet.add_check( MENU_CHECK_MINOR_PLANET_SELECT,	"If̂",	"Selected Objects Only",0,		false );

	//-- TNOj[
	menu_TNO.set_title("znOV", "Transneptunian Objects");
	menu_TNO.add_check( MENU_CHECK_TNO_DISP,		"\",				"Display",					0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_NAME,		"O",				"Names",					0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_ORBIT,		"O",				"Orbits",					0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_SELECT,		"IV̂̂",	"Selected Objects Only",	0,		false );
	menu_TNO.add_check( MENU_CHECK_TNO_OORT_CLOUD,	"I[g̉_",		"Oort Cloud",				0,		false );


	//--- [h ---
	const menu_item_def  mdf_landing_mode[] = {
		{ "n[h",		"Horizontal",		LANDING_MODE_HORIZONTAL },
		{ "n\ώ@[h",	"Surface View",		LANDING_MODE_SURFACE_VIEW }
	};
	init_option_menu( menu_landing_mode, 2, MENU_CHECK_LANDING_MODE, "[h", "Landing Mode", mdf_landing_mode, 0);



	//-- Cj[
	const int menu_atmosphere_num = 3;
	const menu_item_def  mdf_atmosphere[] = {
		{ "Ȃ",				"None",					ATMOSPHERE_NONE },
		{ "iPUj",		"Single Scattering",	ATMOSPHERE_SINGLE },
		{ "idUj",		"Multiple Scattering",	ATMOSPHERE_MULTIPLE }
	};
	init_option_menu( menu_atmosphere, menu_atmosphere_num, MENU_CHECK_PLANET_ATMOSPHERE, "C", "Atmosphere", mdf_atmosphere, AtmosphereMode );

	//-- ̉ej[
	menu_eclipse.set_title("̉e", "Shadow of Moon");
	menu_eclipse.add_check( MENU_CHECK_ECLIPSE_DISP,	"\",				"Display",						0,	false );
	menu_eclipse.add_check( MENU_CHECK_ECLIPSE_BORDER,	"{eEe̋E",	"Borders of Umbra/Penumbra",	0,	false );



	//-- g嗦j[
	const int menu_zoom_mode_num = 4;
	const menu_item_def  mdf_zoom[] = {
		{ "{",	"Real Scale",	0 },
		{ "gP",	"Zoom 1",		1 },
		{ "gQ",	"Zoom 2",		2 },
		{ "gR",	"Zoom 3",		3 }
	};
	init_option_menu( menu_zoom_mode, menu_zoom_mode_num, MENU_CHECK_PLANET_ZOOM, "g嗦", "Zoom Rate", mdf_zoom, get_zoom_mode());


	//-- n`{j[
	const int menu_topo_zoom_num = 5;
	const menu_item_def  mdf_topo_zoom[] = {
		{ "{",	"Real Scale",	0 },
		{ "Q{",	"x2",			1 },
		{ "T{",	"x5",			2 },
		{ "PO{",	"x10",			3 },
		{ "QO{",	"x20",			4 }
	};
	init_option_menu( menu_topo_zoom, menu_topo_zoom_num, MENU_CHECK_TOPO_ZOOM, "n`̔{", "Amplification of Topography", mdf_topo_zoom, get_topo_zoom_mode());

	//-- T@j[
	menu_spacecraft.set_title("O̕\", "Trajectory of Spacecraft");
	for (int i=0; i<5; i++) {
		const bilingual& name = get_spacecraft_name(i);
		menu_spacecraft.add_check( MENU_CHECK_SPACECRAFT_PATH,	name.text_J, name.text_E, i,		false );
	}



	//-- V̐상j[
	const int menu_clst_sphere_num = 4;// WMAP ͎bIɊO
	const menu_item_def  mdf_milkyway[] = {
		{ "Ȃ",				"None",					0 },
		{ "V̐",				"Milky Way",			1 },
		{ "邢V̐",			"Bright Milky Way",		2 },
		{ "ԊOŌV̐",	"Infrared Milky Way",	3 }
	};
	init_option_menu( menu_clst_sphere, menu_clst_sphere_num, MENU_CHECK_MILKYWAY, "V̐", "Milky Way", mdf_milkyway, tyMilkyWay);


	//-- ̓j[
	menu_galaxy.set_title("", "Galaxy");
	menu_galaxy.add_check( MENU_CHECK_OUR_GALAXY,		"͌n",	"Our Galaxy",			0,		false );
	menu_galaxy.add_check( MENU_CHECK_GLOBULAR_CLUSTER,	"󐯒c",	"Globular Clusters",	0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_NEAR,		"ߖT",	"Nearby Galaxies",		0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_SDSS,		"SDSS ", "SDSS Galaxies",		0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_QSO,		"NG[T[", "SDSS QSOs",			0,		false );
	menu_galaxy.add_check( MENU_CHECK_GALAXY_VIRGO,		"Ƃߍ͒c}[N", "Mark Galaxies in Virgo Cluster", 0,	false );


	//-- KChj[
	menu_grid.set_title("oܐEXP[", "Grid/Scale");
	menu_grid.add_check( MENU_CHECK_CLST_GRD,				"ԌoEԈ",	"Equatorial Grid",			0,	false );
	menu_grid.add_check( MENU_CHECK_ECLIPTIC,				"",		"Ecliptic",					0,	false );
	menu_grid.add_check( MENU_CHECK_HORIZON_COORD,			"nW",	"Horizontal Coordinate",	0,	false );
	menu_grid.add_check( MENU_CHECK_GLX_GRD,				"oE",	"Galactic Coordinate",		0,	false );
	menu_grid.add_check( MENU_CHECK_DIST_SCALE,				"XP[i~j",   "Scale Circles",	0,	false );
	menu_grid.add_check( MENU_CHECK_SCALE_SQUARE,			"XP[ilpj", "Scale Squares",	0,	false );


	//-- ^CXebvj[ --
	const int menu_timestep_num = 11;
	const menu_item_def  mdf_timestep[] = {
		{ "POb",	"10 sec",	 0 },
		{ "P",	"1 min",	 1 },
		{ "PO",	"10 min",	 2 },
		{ "P",	"1 hour",	 3 },
		{ "S",	"4 hours",	 4 },
		{ "P",	"1 day",	 5 },
		{ "PT",	"1 week",	 6 },
		{ "P",	"1 month", 	 7 },
		{ "PN",	"1 year",	 8 },
		{ "PON",	"10 years",	 9 },
		{ "POON",	"100 years", 10 }
	};
	init_option_menu( menu_timestep, menu_timestep_num, MENU_CHECK_TIME, "i߂鎞", "Time Step", mdf_timestep, tyTimeStep);


	//-- ꃁj[
	const int menu_lang_num = 3;
	const menu_item_def  mdf_lang[] = {
		{ "{irj",	"Japanese with Kana Reading",	0 },
		{ "{irȂj",	"Japanese",						1 },
		{ "p",				"English",						2 }
	};
	init_option_menu( menu_lang, menu_lang_num, MENU_CHECK_LANG, "̑I", "Language", mdf_lang, get_language());



	//-- color
	const float f=1.3;
	const float alpha = 0.7;
	mnu_col.txt_color.set(0.647,0.623,0.647,1);
	mnu_col.select_color.set(0.87,0.87,0.827,1);
	mnu_col.bg_color.set(0.274,0.305,0.392,0.7);
	mnu_col.bd_color.set(0.36,0.4,0.52,1);
	mnu_col.title_color.set(0.8,0.8,0.6,1);


	const float a = 0.4;
	RGBf c = a * mnu_col.txt_color.rgb;
	mnu_col_bk.txt_color.set(c.x, c.y, c.z, 1);
	c = a * mnu_col.select_color.rgb;
	mnu_col_bk.select_color.set(c.x, c.y, c.z, 1);
	c = a * mnu_col.bg_color.rgb;
	mnu_col_bk.bg_color.set(c.x, c.y, c.z, 0.7);
	c = a * mnu_col.bd_color.rgb;
	mnu_col_bk.bd_color.set(c.x, c.y, c.z, 1);
	c = a * mnu_col.title_color.rgb;
	mnu_col_bk.title_color.set(c.x, c.y, c.z, 1);
}




//-------------
// Check Menu
//-------------
void
set_root_menu_checks()
{
	if (tyProgram==5) {
		menu_root.set_check(virgo_menu_idx, bVirgoCluster);
	}
}




void
set_menu_checks()
{
	//-- [g
	set_root_menu_checks();



	//-- ԑg
	menu_program.set_check(tyProgram);


	//-- ړE^[Qbg
	const int tgt_ID = get_target_ID();
	menu_target_solarsystem.set_check_by_index(tgt_ID);
	menu_target_spacecraft.set_check_by_index(tgt_ID);
	menu_target_galactic.set_check_by_index(tgt_ID);
	menu_target_extragalactic.set_check_by_index(tgt_ID);


	//-- 
	menu_time.set_check(0, bDate);
	menu_time.set_check(3, GetRealtimeMode());
	
	//-- ^CXebv
	menu_timestep.set_check(tyTimeStep);

	//-- VXe
	menu_system.set_check(3, is_fullscreen_mode());
	menu_system.set_check(4, bSubtitles);
	menu_system.set_check(5, bAppTitle);
	menu_system.set_check(6, bAbout);
	menu_system.set_check(7, bDebug);
	menu_system.set_check(8, bSingleEye);

	//--TCY
	for (int i=0; i<5; i++) {
		if (FontSize == vFontSize[i]) {
			menu_font_size.set_check(i);
		}
	}

	//-- pX
	menu_path.set_check(0, bPathInfo);


	//-- \ݒ
	menu_disp.set_check( 9, bNGC);
	menu_disp.set_check(12, bSideLight);
	menu_disp.set_check(13, bSurfacePointer);
	menu_disp.set_check(14, bViewInfo);


	//-- 
	menu_cnst.set_check(0, swConstellation & CNST_NAME);
	menu_cnst.set_check(1, swConstellation & CNST_LINE);
	menu_cnst.set_check(2, swConstellation & CNST_ILLUST);
	menu_cnst.set_check(3, swConstellation & CNST_BND);
	//-- P
	menu_star.set_check(0,  swStar & STAR_DISP);
	menu_star.set_check(1,  swStar & STAR_NAME);
	menu_star.set_check(2,  swStar & STAR_NAME_SELECT);
	menu_star.set_check(3,  swStar & STAR_BAYER);
	menu_star.set_check(4,  swStar & STAR_FRAMSTEED);
	menu_star.set_check(5,  swStar & STAR_HIP);
	//-- ̃}[N
	menu_star_mark.set_check(tyStarMark);

	//--  f
	menu_planet.set_check(0,	test_disp_switch(DISPSW_PLANET,			DISPM_DISP));
	menu_planet.set_check(1,	test_disp_switch(DISPSW_PLANET,			DISPM_NAME));
	menu_planet.set_check(2,	test_disp_switch(DISPSW_PLANET,			DISPM_ORBIT));
	menu_planet.set_check(3,	test_disp_switch(DISPSW_PLANET,			DISPM_AXIS));
	menu_planet.set_check(5,	test_disp_switch(DISPSW_PLANET,			DISPM_CLOUD));
	menu_planet.set_check(6,	test_disp_switch(DISPSW_PLANET,			DISPM_CITY_LIGHTS));

	//--  q
	menu_satellite.set_check(0,	test_disp_switch(DISPSW_SATELLITE,		DISPM_DISP));
	menu_satellite.set_check(1,	test_disp_switch(DISPSW_SATELLITE,		DISPM_NAME));
	menu_satellite.set_check(2,	test_disp_switch(DISPSW_SATELLITE,		DISPM_ORBIT));
	menu_satellite.set_check(3,	test_disp_switch(DISPSW_SATELLITE,		DISPM_SELECT));

	//--  f
	menu_minor_planet.set_check(0,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_DISP));
	menu_minor_planet.set_check(1,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_NAME));
	menu_minor_planet.set_check(2,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_ORBIT));
	menu_minor_planet.set_check(3,	test_disp_switch(DISPSW_MINOR_PLANET,		DISPM_SELECT));

	//--  TNO
	menu_TNO.set_check(0,	test_disp_switch(DISPSW_TNO,		DISPM_DISP));
	menu_TNO.set_check(1,	test_disp_switch(DISPSW_TNO,		DISPM_NAME));
	menu_TNO.set_check(2,	test_disp_switch(DISPSW_TNO,		DISPM_ORBIT));
	menu_TNO.set_check(3,	test_disp_switch(DISPSW_TNO,		DISPM_SELECT));
	menu_TNO.set_check(4,	bOortCloud);


	//-- C
	menu_atmosphere.set_check(AtmosphereMode);

	//--  ̉e
	menu_eclipse.set_check(0, swEclipse & ECLIPSE_DISP);
	menu_eclipse.set_check(1, swEclipse & ECLIPSE_BORDER);


	//-- g嗦
	menu_zoom_mode.set_check(get_zoom_mode());
	menu_topo_zoom.set_check(get_topo_zoom_mode());

	//-- [h
	menu_landing_mode.set_check(get_landing_mode());

	//-- T@
	for (int i=0; i<5; i++) {
		menu_spacecraft.set_check(i, get_spacecraft_path_mode(i) );
	}

	//-- 
	menu_galaxy.set_check(0, swGalaxy & GLXY_OUR_GALAXY);
	menu_galaxy.set_check(1, swGalaxy & GLXY_GLOB_CLSTR);
	menu_galaxy.set_check(2, swGalaxy & GLXY_NEARBY_GALAXY);
	menu_galaxy.set_check(3, swGalaxy & GLXY_DISTANT_GALAXY);
	menu_galaxy.set_check(4, swGalaxy & GLXY_QSO);
	menu_galaxy.set_check(5, bVirgoCluster);

	//-- V̐
	menu_clst_sphere.set_check(tyMilkyWay);

	//-- KCh
	menu_grid.set_check(0, bCelestialGrid);
	menu_grid.set_check(1, bEcliptic);
	menu_grid.set_check(2, bHorizonCoord);
	menu_grid.set_check(3, bGalacticGrid);
	menu_grid.set_check(4, swScaleLine & SCALE_CIRCLE);
	menu_grid.set_check(5, swScaleLine & SCALE_SQUARE);

	//-- 
	char lang = get_language();
	menu_lang.set_check(lang);
}





//-----------
//  Execute
//-----------
void
OnEnterMenu()
{
	if (bControler)	{ send_command(COMMAND_MENU_ENTER); }

	//
	set_sub_mode( SUBMODE_MENU );
	mnuSelect.clear();
	mnuSelect.push_back(&menu_root);
	menu_root.set_current_pos(0);

	OnMenuFade(0);
	float v = 1 / GetMenuFadeDuration();
	SetMenuFadeVelocity(v);
}

void
OnLeaveMenu()
{
	set_sub_mode( SUBMODE_NORMAL );
	mnuSelect.clear();
}

void
OnCloseMenu()
{
	if (bControler)	{ send_command(COMMAND_MENU_CLOSE); }

	if (mnuSelect.size() == 1)	{ OnLeaveMenu();  }
	else						{ mnuSelect.pop_back(); }
}


void
OnMenuPos(int pos)
{
	if (bControler)	{ send_data_char(DATA_CHAR_MENU_POS, pos); }

	menu&  mnu = *mnuSelect.back();
	mnu.set_current_pos(pos);
}

void
OnMenuAngle(float angle)
{
	menu_angle = angle;
	if (menu_angle < 0)   menu_angle += 360;
	if (menu_angle > 360) menu_angle -= 360;

	if (bControler)	{ send_data_float(DATA_FLOAT_MENU_ANGLE, menu_angle); }
}

void
OnMenuFade(float fac)
{
	if (bControler) { send_data_float(DATA_FLOAT_MENU_FADE_FACTOR, fac); }
	SetMenuFadeFactor(fac);
}


void
OnExecMenu()
{
	menu&  mnu = *mnuSelect.back();
	int pos = mnu.get_current_pos();
	switch (mnu[pos]->get_type()) {
		case MENU_TY_CHILD:
			{
				menu*  pMnuChild = ((menu_item_child*)mnu[pos])->get_child_menu();
				mnuSelect.push_back( pMnuChild );
				pMnuChild->set_current_pos_auto();

				OnMenuFade(0);
				float v = 1 / GetMenuFadeDuration();
				SetMenuFadeVelocity(v);

				if (bControler)	{ send_command(COMMAND_MENU_EXEC); }
			}
			break;
		case MENU_TY_COMMAND:
			{
				menu_item_command&  mtc = *(menu_item_command*)(mnu[pos]);
				int ID = mtc.get_ID();
				const int idx = mtc.get_idx();

				switch (ID) {
					case MENU_COMMAND_CLOSE:				OnCloseMenu();						return;
					case MENU_COMMAND_EXIT_ALL:				OnExitAll();						return;

					case MENU_COMMAND_SCALE:				OnPresetScale(idx);					return;

					case MENU_COMMAND_MOVIE_OPEN:			OnMovieOpenControler(idx);			return;
					case MENU_COMMAND_IMAGE_OPEN:			OnImageOpenControler(idx);			return;
					case MENU_COMMAND_AUDIO_OPEN:			OnAudioOpenControler(idx);			return;
					case MENU_COMMAND_3DCHART:				OnOpen3DChart(idx);					return;

					case MENU_COMMAND_LANDING_INIT:			OnLandingInit();					return;

					case MENU_COMMAND_STAR_BRIGHTEN:		OnLRef( pow(10, -0.4*0.5) );		return;
					case MENU_COMMAND_STAR_DARKEN:			OnLRef( pow(10, +0.4*0.5) );		return;
					case MENU_COMMAND_STAR_DEFAULT_BRIGHTNESS:	OnSetLRef( 1.0f );				return;
					case MENU_COMMAND_PRESENT_TIME:			OnPresentTime();					return;
					case MENU_COMMAND_TARGET_MOVE:			OnTargetMoveControler();			return;
					case MENU_COMMAND_RESET_VIEWANGLE:		OnResetViewangle();					return;
					case MENU_COMMAND_PRESET:				OnPreset(idx);						return;
					case MENU_COMMAND_PLAY_PATH:			OnPlayFrame(true);					return;
					case MENU_COMMAND_SAVE_PATH:			OnSavePath();						return;
					case MENU_COMMAND_LOAD_PATH:			OnLoadPath();						return;
					case MENU_COMMAND_CLEAR_PATH:			OnClearPath();						return;
					
					case MENU_COMMAND_GOTO:
						{
							if (get_mode() != MODE_3D)  return;
							int tgt_ID = get_preset_target_ID( idx );
							OnChangeTargetControler( tgt_ID );

							if (idx == TGT_CASSINI) {
								OnTargetMoveControler();
							}

						}
						return;
					
					case MENU_COMMAND_DRAW_MILKYWAY:		OnMilkyWay(MILKYWAY_VISIBLE);				return;
					case MENU_COMMAND_DRAW_MILKYWAY2:		OnMilkyWay(MILKYWAY_VISIBLE2);				return;
					default:	return;
				}
				break;
			}
		case MENU_TY_CHECK:
			{
				menu_item_check&  mtck = *(menu_item_check*)(mnu[pos]);
				bool bChk = !mtck.get_check();
				mtck.set_check( bChk );

				const int ID = mtck.get_ID();
				const int idx = mtck.get_idx();

				switch (ID) {
					case MENU_CHECK_TARGET:				if (get_mode() == MODE_3D)		OnChangeTargetControler(idx);	return;

					case MENU_CHECK_CNST_NAME:			OnCnstSet(CNST_NAME,	bChk);		return;
					case MENU_CHECK_CNST_LINE:			OnCnstSet(CNST_LINE,	bChk);		return;
					case MENU_CHECK_CNST_ILLUST:		OnCnstSet(CNST_ILLUST,	bChk);		return;
					case MENU_CHECK_CNST_BND:			OnCnstSet(CNST_BND,		bChk);		return;

					case MENU_CHECK_STAR:				OnStarSet(STAR_DISP,		bChk);	return;
					case MENU_CHECK_STAR_NAME:			OnStarSet(STAR_NAME,		bChk);	return;
					case MENU_CHECK_STAR_NAME_SELECT:	OnStarSet(STAR_NAME_SELECT,	bChk);	return;
					case MENU_CHECK_STAR_BAYER:			OnStarSet(STAR_BAYER,		bChk);	return;
					case MENU_CHECK_STAR_FRAMSTEED:		OnStarSet(STAR_FRAMSTEED,	bChk);	return;
					case MENU_CHECK_STAR_HIP:			OnStarSet(STAR_HIP,			bChk);	return;

					case MENU_CHECK_STAR_MARK:			OnStarMark( idx );					return;

				
					//--  Planet
					case MENU_CHECK_PLANETS:			OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_DISP,			bChk);	return;
					case MENU_CHECK_PLANET_NAME:		OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_NAME, 		bChk);	return;
					case MENU_CHECK_PLANET_ORBIT:		OnDispSwitchSetBit(DISPSW_PLANET, 	DISPM_ORBIT, 		bChk);	return;
					case MENU_CHECK_PLANET_AXIS:		OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_AXIS,			bChk);	return;
					case MENU_CHECK_PLANET_CLOUD:		OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_CLOUD,		bChk);	return;
					case MENU_CHECK_PLANET_CITY_LIGHTS:	OnDispSwitchSetBit(DISPSW_PLANET,	DISPM_CITY_LIGHTS,	bChk);	return;

					//--  Satellite
					case MENU_CHECK_SATELLITE_DISP:		OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_DISP,			bChk);	return;
					case MENU_CHECK_SATELLITE_NAME:		OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_NAME,			bChk);	return;
					case MENU_CHECK_SATELLITE_ORBIT:	OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_ORBIT,		bChk);	return;
					case MENU_CHECK_SATELLITE_SELECT:	OnDispSwitchSetBit(DISPSW_SATELLITE,	DISPM_SELECT,		bChk);	return;

					//--  Minor Planet
					case MENU_CHECK_MINOR_PLANET_DISP:		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_DISP,		bChk);	return;
					case MENU_CHECK_MINOR_PLANET_NAME:		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_NAME,		bChk);	return;
					case MENU_CHECK_MINOR_PLANET_ORBIT:		OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_ORBIT,	bChk);	return;
					case MENU_CHECK_MINOR_PLANET_SELECT:	OnDispSwitchSetBit(DISPSW_MINOR_PLANET,	DISPM_SELECT,	bChk);	return;

					//--  TNOs
					case MENU_CHECK_TNO_DISP:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_DISP,		bChk);	return;
					case MENU_CHECK_TNO_NAME:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_NAME,		bChk);	return;
					case MENU_CHECK_TNO_ORBIT:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_ORBIT,	bChk);	return;
					case MENU_CHECK_TNO_SELECT:		OnDispSwitchSetBit(DISPSW_TNO,	DISPM_SELECT,	bChk);	return;
					case MENU_CHECK_TNO_OORT_CLOUD:	OnOortCloud(bChk);										return;
						
					case MENU_CHECK_PLANET_ATMOSPHERE:	OnPlanetAtmosphere(idx);		return;
					case MENU_CHECK_PLANET_ZOOM:		OnZoomMode(idx);				return;
					case MENU_CHECK_TOPO_ZOOM:			OnTopoZoomMode(idx);			return;
					case MENU_CHECK_LANDING_MODE:		OnLandingMode(idx);				return;

					case MENU_CHECK_ECLIPSE_DISP:		OnEclipseSet(ECLIPSE_DISP,		bChk);	return;
					case MENU_CHECK_ECLIPSE_BORDER:		OnEclipseSet(ECLIPSE_BORDER,	bChk);	return;

					case MENU_CHECK_SPACECRAFT_PATH:	OnSpacecraftPath(idx, bChk);	return;

					case MENU_CHECK_OUR_GALAXY:			OnGalaxySet(GLXY_OUR_GALAXY, bChk);		return;
					case MENU_CHECK_GLOBULAR_CLUSTER:	OnGalaxySet(GLXY_GLOB_CLSTR, bChk);		return;
					case MENU_CHECK_GALAXY_NEAR:		OnGalaxySet(GLXY_NEARBY_GALAXY, bChk);	return;
					case MENU_CHECK_GALAXY_SDSS:		OnGalaxySet(GLXY_DISTANT_GALAXY, bChk);		return;
					case MENU_CHECK_GALAXY_QSO:			OnGalaxySet(GLXY_QSO, bChk);			return;
					case MENU_CHECK_GALAXY_VIRGO:		OnMarkVirgoCluster(bChk);				return;

					case MENU_CHECK_MILKYWAY:		OnMilkyWay(idx);					return;

					case MENU_CHECK_NGC:			OnNGC(bChk);						return;

					case MENU_CHECK_CLST_GRD:		OnCelestialGrid(bChk);				return;
					case MENU_CHECK_ECLIPTIC:		OnEcliptic(bChk);					return;
					case MENU_CHECK_HORIZON_COORD:	OnHorizonCoord(bChk);				return;
					case MENU_CHECK_GLX_GRD:		OnGalacticGrid(bChk);				return;

					case MENU_CHECK_DIST_SCALE:		OnDistScaleSet(SCALE_CIRCLE, bChk);	return;
					case MENU_CHECK_SCALE_SQUARE:	OnDistScaleSet(SCALE_SQUARE, bChk);	return;

					case MENU_CHECK_SIDE_LIGHT:		OnSideLight(bChk);					return;
					case MENU_CHECK_SURFACE_POINTER:OnSurfacePointer(bChk);				return;

					case MENU_CHECK_DATE:			OnDate(bChk);						return;
					case MENU_CHECK_TIME:			OnTimeStep(idx);					return;
					case MENU_CHECK_REALTIME_MODE:	OnRealTimeMode(bChk);				return;

					case MENU_CHECK_LANG:			OnLang(idx);						return;

					case MENU_CHECK_TEST:			OnTest(bChk);						return;

					case MENU_CHECK_PROGRAM: 		OnProgram(idx);						return;

					case MENU_CHECK_FONT_SIZE: 		OnFontSize(idx);					return;

					case MENU_CHECK_FULLSCREEN:		OnFullScreen(bChk);					return;
					case MENU_CHECK_SUBTITLES:		OnSubtitles(bChk);					return;
					case MENU_CHECK_TITLE:			OnTitle(bChk);						return;
					case MENU_CHECK_ABOUT:			OnCheckAbout(bChk);					return;
					case MENU_CHECK_DEBUG:			OnDebug(bChk);						return;
					case MENU_CHECK_VIEW_INFO:		OnViewInfo(bChk);					return;
					case MENU_CHECK_SINGLE_EYE:		OnSingleEye(bChk);					return;
					
					case MENU_CHECK_PATH_INFO:		OnPathInfo(bChk);					return;

					default:															return;
				}
				break;
			}
			break;
		default:
			return;
	}
}





//-------------
//  Draw menu
//-------------
inline RGBf
calc_menu_bg_color(RGBf& col1, RGBf& col2, float h, float y)
{
	float f2 = fabs(y)/h;
	float f1 = 1 - f2;
	
	return f1 * col1 + f2 * col2;
}

inline void
set_menu_bg_color(RGBf& col1, RGBf& col2, float h, float y, float alp)
{
	RGBf col = calc_menu_bg_color(col1, col2, h, y);
	glColor4f(col.r, col.g, col.b, alp);
}

void
draw_menu_background(float w, float h, float R, float alp, int sel_idx, float mgn_y)
{
	const int csN = 10;
	static bool bFirst = true;
	static float cs[csN], sn[csN];
	if (bFirst) {
		bFirst = false;

		for (int i=0; i<csN; i++) {
			float th = 0.5*M_PI * float(i)/(csN-1);
			cs[i] = cos(th);
			sn[i] = sin(th);
		}
	}



	const float x1 = R;
	const float y1 = -R;
	const float x2 = w-R;
	const float y2 = -h+R;
	const float ys1 = -sel_idx + mgn_y;
	const float ys2 = ys1 - 1;



	//--------------
	//  Background
	//--------------


	//-- Quads --
	RGBf col1  = colMenuBgColor1;
	RGBf col2  = colMenuBgColor2;
	RGBf col11 = calc_menu_bg_color(col1, col2, h, y1);
	RGBf col21 = calc_menu_bg_color(col1, col2, h, y2);
	RGBf col1s = calc_menu_bg_color(col1, col2, h, ys1);
	RGBf col2s = calc_menu_bg_color(col1, col2, h, ys2);
	RGBf colhl1 = colMenuHlColor1;
	RGBf colhl2 = colMenuHlColor2;

	glBegin(GL_QUADS);
		// Top
		glColor4f(col1.r, col1.g, col1.b, alp);
		glVertex3f(x2, 0, 0);
		glVertex3f(x1, 0, 0);
		glColor4f(col11.r, col11.g, col11.b, alp);
		glVertex3f(x1,y1, 0);
		glVertex3f(x2,y1, 0);
		// Top2
		glColor4f(col11.r, col11.g, col11.b, alp);
		glVertex3f(w, y1, 0);
		glVertex3f(0, y1, 0);
		glColor4f(col1s.r, col1s.g, col1s.b, alp);
		glVertex3f(0, ys1, 0);
		glVertex3f(w, ys1, 0);

		// Highlight
		glColor4f(colhl1.r, colhl1.g, colhl1.b, alp);
		glVertex3f(w, ys1, 0);
		glVertex3f(0, ys1, 0);
		glColor4f(colhl2.r, colhl2.g, colhl2.b, alp);
		glVertex3f(0, ys2, 0);
		glVertex3f(w, ys2, 0);


		// Bottom2
		glColor4f(col2s.r, col2s.g, col2s.b, alp);
		glVertex3f(w, ys2, 0);
		glVertex3f(0, ys2, 0);
		glColor4f(col21.r, col21.g, col21.b, alp);
		glVertex3f(0, y2, 0);
		glVertex3f(w, y2, 0);
		// Bottom
		glColor4f(col21.r, col21.g, col21.b, alp);
		glVertex3f(x2, y2, 0);
		glVertex3f(x1, y2, 0);
		glColor4f(col21.r, col21.g, col21.b, alp);
		glVertex3f(x1, -h, 0);
		glVertex3f(x2, -h, 0);

	glEnd();
	

	//-- Corner --
	float xc, yc;
	
	xc = x1;	yc = y1;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = R*cs[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(-R*sn[i]+xc, y, 0);
		}
	glEnd();

	xc = x1;	yc = y2;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = -R*sn[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(-R*cs[i]+xc, y, 0);
		}
	glEnd();

	xc = x2;	yc = y2;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = -R*cs[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(R*sn[i]+xc, y, 0);
		}
	glEnd();

	xc = x2;	yc = y1;
	glBegin(GL_TRIANGLE_FAN);
		set_menu_bg_color(col1, col2, h, yc, alp);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float y = R*sn[i]+yc;
			set_menu_bg_color(col1, col2, h, y, alp);
			glVertex3f(R*cs[i]+xc, y, 0);
		}
	glEnd();




	
	//----------
	//  Border
	//----------
	const RGBf cbd = colMenuBdColor;
	glColor4f(cbd.r, cbd.g, cbd.b, alp); 
	glLineWidth(MenuBdWidth);
	
	glBegin(GL_LINE_STRIP);
		// LT
		xc = x1;
		yc = y1;
		for (int i=0; i<csN; i++) {
			glVertex3f(-R*sn[i]+xc, R*cs[i]+yc, 0);
		}
		// LB
		xc = x1;
		yc = y2;
		for (int i=0; i<csN; i++) {
			glVertex3f(-R*cs[i]+xc, -R*sn[i]+yc, 0);
		}
		// RB
		xc = x2;
		yc = y2;
		for (int i=0; i<csN; i++) {
			glVertex3f(R*sn[i]+xc, -R*cs[i]+yc, 0);
		}
		// RT
		xc = x2;
		yc = y1;
		for (int i=0; i<csN; i++) {
			glVertex3f(R*cs[i]+xc, R*sn[i]+yc, 0);
		}
		glVertex3f(x1,0,0);
	glEnd();

}


void
draw_menu_triangle(float sz)
{
	float l = sz;

	float y0 = 0.5;
	float y1 = y0 - 0.5*l;
	float y2 = y0 + 0.5*l;
	float x1 = 0.78*l;
	float d  = 0.1*l;


	glBegin(GL_TRIANGLE_FAN);
		glVertex3f(x1-2*d, y0,   0);
		glVertex3f(  -d, y1+d, 0);
		glVertex3f(   0, y1,   0);
		glVertex3f(  x1, y0,   0);
		glVertex3f(   0, y2,   0);
		glVertex3f(  -d, y2-d,   0);
	glEnd();
}


void
draw_menu_diamond(float sz)
{
	float l = sz;

	float x0 = 0.5;
	float y0 = 0.5;
	float x1 = x0 - 0.5*l;
	float x2 = x0 + 0.5*l;
	float y1 = y0 - 0.5*l;
	float y2 = y0 + 0.5*l;


	glBegin(GL_TRIANGLE_FAN);
		glVertex3f(x0, y2, 0);
		glVertex3f(x1, y0, 0);
		glVertex3f(x0, y1, 0);
		glVertex3f(x2, y0, 0);
	glEnd();
}



void
draw_each_menu(menu* pMenu, float x0, float y0, float z0, menu_color& mnc, const float alp1, const float alp2, const float scl)
{
	const char lang = get_language();
	const float szT = 1.1f;

	const float dz = 0.1;
	menu&  mnu = *pMenu;
	glTranslatef(x0,-y0,z0);

	//--- ̈TCY̌vZ
	bool bCheck = false;
	float w, h;
	
	const char* title = (lang == LANG_ENG)  ?  mnu.get_titleE() : mnu.get_titleJ();
	get_text_size(title, w,h);	// ^Cg
	
	h *= szT;
	float hT = h;

	h += 0.5;
	for (int i=0; i<pMenu->size(); ++i) {
		char ty = mnu[i]->get_type();
		if (ty == MENU_TY_CHECK)  bCheck=true;

		const char* name = (lang == LANG_ENG)  ?  mnu[i]->get_name_E() : mnu[i]->get_name_J();

		float dw, dh;
		if (ty == MENU_TY_CHILD) {
			char str[256];
			sprintf(str, "%s", name);
			get_text_size(str, dw, dh);
			dw += 0.5 + 0.6;
		} else {
			get_text_size(name, dw, dh);
		}
		
		if (w < dw)  w = dw;
		h += dh;
	}

	float xx=0;
	if (bCheck) xx=1;

	//--- wi̕`
	const float mgn_x = 0.4;
	const float mgn_y = 0.4;
	float x2,y2;
	x2 = w + xx + 2*mgn_x;
	y2 = h + 2*mgn_y;


	//-- Backgroud
	const float _mgny = -mgn_y-hT-0.5;
	draw_menu_background(x2, y2, MenuCornerR, alp2, mnu.get_current_pos(), _mgny);


	glLineWidth(1);

	glTranslatef(mgn_x, -mgn_y-hT, 0);


	//--- j[^Cg̕\
	glColor4f(colMenuTitle.r, colMenuTitle.g, colMenuTitle.b, alp1);
	glPushMatrix();
		glScalef(szT, szT, szT);
		draw_text(title);
	glPopMatrix();
	glTranslatef(0,-1.5,0);
	glTranslatef(0, 0.15,0);	//*** 



	//--- `FbN̕\
	glColor4f(colMenuSelect.r, colMenuSelect.g, colMenuSelect.b, alp1);
	if (bCheck) {
		glPushMatrix();
		for (int i=0; i<pMenu->size(); ++i) {
			if (mnu[i]->get_type() == MENU_TY_CHECK) {
				if (((menu_item_check*)mnu[i])->get_check()) {
					glPushMatrix();
						glTranslatef(0.0, -0.15 + MenuTriangleDy, 0);
						draw_menu_diamond(0.6);
					glPopMatrix();
				}
			}
			glTranslatef(0,-1,0);
		}
		glPopMatrix();
		glTranslatef(xx,0,0);
	}


	//--- j[̕`
	for (int i=0; i<pMenu->size(); ++i) {
		glPushMatrix();
		if (mnu.get_current_pos() == i)	{
			glColor4f(colMenuSelect.r, colMenuSelect.g, colMenuSelect.b, alp1);
			glTranslatef(0,0,dz);
		} else {
			glColor4f(colMenuText.r, colMenuText.g, colMenuText.b, alp1);
		}

		char ty = (*pMenu)[i]->get_type();
		const char* text = (lang == LANG_ENG)  ?  (*pMenu)[i]->get_name_E()  :  (*pMenu)[i]->get_name_J();
		if (ty == MENU_TY_CHILD)	{
			draw_textf("%s", text);
			glTranslatef(0.5, -0.15 + MenuTriangleDy, 0);

			if (mnu.get_current_pos() == i)	{
				glColor4f(0.7*colMenuSelect.r, 0.7*colMenuSelect.g, 0.7*colMenuSelect.b, alp1);
			} else {
				glColor4f(0.7*colMenuText.r, 0.7*colMenuText.g, 0.7*colMenuText.b, alp1);
			}
			draw_menu_triangle(0.6);
		} else {
			draw_textf("%s",   text);
		}

		glPopMatrix();
		glTranslatef(0,-1,0);
	}
}



void
set_menu_pos0(const float angle)
{
	const double* Mbc;
	Mbc = get_local_camera_matrix_GL();

	glLoadIdentity();
	glMultMatrixd(Mbc);

	
	double M[16];
	quaternion_to_matrix_GL_tr( get_base_camera_ori(), M );
	glMultMatrixd(M);
	

	glRotatef(-menu_angle + angle  ,0,1,0);
	glTranslatef(0,0,-1.2*get_screen_z());
}






void
set_menu_pos(const float angle)
{
	set_menu_pos0(angle);
	glTranslatef(-0.5*get_screen_w(),0.5*get_screen_w(),0);
}


void
draw_menu(menu_selection& ms, float x0, float y0, float z0)
{
	set_menu_checks();

	float scl = 0.055 * get_screen_w();
	float step = 0.8;
	float step_z = 0.5;

	scl *= MenuTextSize;//****

	glPushMatrix();
		set_menu_pos( get_menu_pos_angle() );

		glRotatef( get_menu_rotate_angle(), 0,1,0);

		glDisable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND);

		glScalef(scl,scl,scl);
		for (int i=0; i<ms.size(); ++i) {
			float alp1, alp2, dz;
			const float fac = GetMenuFadeFactor();
			float scl;

			if (i==ms.size()-1) {
				// top window ̏ꍇ
				alp1 = 1.0f * fac;
				alp2 = MenuBgAlpha * fac;
				dz = -(1-fac);
				scl = fac;
			} else {
				float alp1a, alp1b;
				if (i==ms.size()-2) {
					alp1a = 1.0f;
				} else {
					alp1a = MenuBehindAlpha * (1 - float(ms.size()-3 -i)/MenuFadingRate);
				}
				alp1b = MenuBehindAlpha * (1 - float(ms.size()-2 -i)/MenuFadingRate);
				alp1 = alp1a * (1-fac) + alp1b * fac;
				alp2 = MenuBgAlpha * alp1;
				dz = 0;
				scl = 1;
			}

			glPushMatrix();
				menu_color& mnc = (i==ms.size()-1) ? mnu_col : mnu_col_bk;
				draw_each_menu(ms[i], x0 + (i)*step, y0 + (i)*step, z0 + (i+dz)*step_z, mnc, alp1, alp2, scl);
			glPopMatrix();
		}
	
		glEnable(GL_DEPTH_TEST);
	glPopMatrix();
}
